#include "Arduino.h"
#include "tempmon.h"
#define pdbser1 Serial

void Panic_Temp_isr(void){
  if(((PMU_MISC1 & (1 << 27)) >> 27) == 1){
          //Serial.println();
          //Serial.println("Powering Down");
          //Serial.flush();delay(500);
          //Thank you Frank
          arm_power_down();
  }
}

//this function gets added to tempmon.c
int getTempAlarm(void){
  if(((PMU_MISC1 & (1 << 29)) >> 29) == 1){
    return 1;
  }
  return 0;
}

void setup() {
  Serial.begin(9600);
  pinMode(13, OUTPUT);
  //Shutdown ISR gets added to startup.c
  attachInterruptVector(IRQ_TEMPERATURE_PANIC, &Panic_Temp_isr);
  NVIC_ENABLE_IRQ(IRQ_TEMPERATURE_PANIC); 
  //resetReason( SRC_SRSR );
  tempmon_init();
}

void loop() {
  // put your main code here, to run repeatedly:
  Serial.println(tempmonGetTemp());
  if(getTempAlarm()){
    digitalWrite(13, HIGH);
  }
  delay(1000);
}

void resetReason( int resetReasonHw ) {
  uint16_t mask, masked_n, thebit;
  uint8_t bit;
  
  pdbser1.print(">>> Reason for 'reset': ");
  pdbser1.print(resetReasonHw, HEX);

  for(bit = 0; bit <= 8; bit++){
    mask =  1 << bit;
    masked_n = resetReasonHw & mask;
    thebit = masked_n >> bit;
    // SRC_SRSR
    if(bit==0 && thebit == 1)  pdbser1.print(" IPP_RESET_B");
    if(bit==1 && thebit == 1)  pdbser1.print(" LOCKUP_SYSRESETREQ");  
    if(bit==2 && thebit == 1)  pdbser1.print(" CSU_RESET_B"); 
    if(bit==3 && thebit == 1)  pdbser1.print(" IPP_USER_RST"); 
    if(bit==4 && thebit == 1)  pdbser1.print(" WDOG_RST_B");
    if(bit==5 && thebit == 1)  pdbser1.print(" JTAG_RST_B");
    if(bit==6 && thebit == 1)  pdbser1.print(" JTAG_SW_RST");
    if(bit==7 && thebit == 1)  pdbser1.print(" WDOG3_RST_B");
    if(bit==8 && thebit == 1)  pdbser1.print(" TEMPSENSE_RST_B");
  }
  pdbser1.println(" :: done Reason");
}

FLASHMEM __attribute__((noreturn))
void arm_power_down() {
    SNVS_LPCR |= SNVS_LPCR_TOP; //Switch off now
    asm volatile ("dsb");
    while (1) asm ("wfi");
}
